# -*- coding: utf-8 -*-

# Define here the models for your spider middleware
#
# See documentation in:
# http://doc.scrapy.org/en/latest/topics/spider-middleware.html

from scrapy import signals
from scrapy.http import HtmlResponse
from scrapy.utils.python import to_bytes
from selenium import webdriver

class WbCrawlJSDownloadMiddleware(object):
    @classmethod
    def from_crawler(cls, crawler):
        middleware = cls()
        crawler.signals.connect(middleware.spider_opened, signals.spider_opened)
        crawler.signals.connect(middleware.spider_closed, signals.spider_closed)
        return middleware

    def process_request(self, request, spider):
        request.meta['driver'] = self.driver  # to access driver from response
        self.driver.get(request.url)
        body = to_bytes(self.driver.page_source)  # body must be of type bytes 
        return HtmlResponse(self.driver.current_url, body = body, encoding = "utf-8", request = request)

    def spider_opened(self, spider):
        self.driver = webdriver.PhantomJS(executable_path = "/home/mikk/Documents/worldbank/analysis/01_crawler/wb_crawl/phantomjs",
                                          service_args = ["--webdriver-loglevel=NONE"],
                                          service_log_path = "/dev/null")

    def spider_closed(self, spider):
        self.driver.close()
